//------------------------------------------------------------------------------
// <auto-generated>
//      Generated by NativeAssist version 1.0.0.0 with Split Generator.
//      Do not modify this file unless necessary.
// </auto-generated>
//------------------------------------------------------------------------------

namespace NativeFx.Interop;

using System;
using GTA.Native;
using GTA;
using GTA.Math;

public static partial class Natives 
{
public static class Pathfind {
/// <summary>
/// When nodeEnabled is set to false, all nodes in the area get disabled.<br />`GET_VEHICLE_NODE_IS_SWITCHED_OFF` returns true afterwards.<br />If it&apos;s true, `GET_VEHICLE_NODE_IS_SWITCHED_OFF` returns false.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xBF1A602B5BA52FEE<br />
/// </para>
/// </remarks>
public static void SetRoadsInArea(float x1, float y1, float z1, float x2, float y2, float z2, bool nodeEnabled, bool unknown2){
Function.Call((Hash)0xBF1A602B5BA52FEEuL, x1, y1, z1, x2, y2, z2, nodeEnabled, unknown2);
}

/// <summary>
/// unknown3 is related to `SEND_SCRIPT_WORLD_STATE_EVENT &gt; CNetworkRoadNodeWorldStateData` in networked environments.<br />See IS_POINT_IN_ANGLED_AREA for the definition of an angled area.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x1A5AA1208AF5DB59<br />
/// </para>
/// </remarks>
public static void SetRoadsInAngledArea(float x1, float y1, float z1, float x2, float y2, float z2, float width, bool unknown1, bool unknown2, bool unknown3){
Function.Call((Hash)0x1A5AA1208AF5DB59uL, x1, y1, z1, x2, y2, z2, width, unknown1, unknown2, unknown3);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x34F060F4BF92E018<br />There were parameter(s) that was labeled as <b>Any</b>, and these had been written as <c>int</c> by generator.
/// </para>
/// </remarks>
public static void SetPedPathsInArea(float x1, float y1, float z1, float x2, float y2, float z2, bool p6, int /* bug: Any */ p7){
Function.Call((Hash)0x34F060F4BF92E018uL, x1, y1, z1, x2, y2, z2, p6, p7);
}

/// <summary>
/// Flags are:<br />1 = 1 = B02_IsFootpath<br />2 = 4 = !B15_InteractionUnk<br />4 = 0x20 = !B14_IsInterior<br />8 = 0x40 = !B07_IsWater<br />16 = 0x200 = B17_IsFlatGround<br />When onGround == true outPosition is a position located on the nearest pavement.<br /><br />When a safe coord could not be found the result of a function is false and outPosition == Vector3.Zero.<br /><br />In the scripts these flags are used: 0, 14, 12, 16, 20, 21, 28. 0 is most commonly used, then 16. <br /><br />16 works for me, 0 crashed the script.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xB61C8E878A4199CA<br />
/// </para>
/// </remarks>
public static bool GetSafeCoordForPed(float x, float y, float z, bool onGround, ref Vector3 outPosition, int flags){
var nativeAssistPointerVar0 = outPosition;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0xB61C8E878A4199CAuL, x, y, z, onGround, &nativeAssistPointerVar0, flags);
}
outPosition = nativeAssistPointerVar0;
return retVal;
}

/// <summary>
/// https://gtaforums.com/topic/843561-pathfind-node-types
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x240A18690AE96513<br />
/// </para>
/// </remarks>
public static bool GetClosestVehicleNode(float x, float y, float z, ref Vector3 outPosition, int nodeFlags, float p5, float p6){
var nativeAssistPointerVar0 = outPosition;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0x240A18690AE96513uL, x, y, z, &nativeAssistPointerVar0, nodeFlags, p5, p6);
}
outPosition = nativeAssistPointerVar0;
return retVal;
}

/// <summary>
/// Get the closest vehicle node to a given position.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x2EABE3B06F58C1BE<br />
/// </para>
/// </remarks>
public static bool GetClosestMajorVehicleNode(float x, float y, float z, ref Vector3 outPosition, float unknown1, float unknown2){
var nativeAssistPointerVar0 = outPosition;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0x2EABE3B06F58C1BEuL, x, y, z, &nativeAssistPointerVar0, unknown1, unknown2);
}
outPosition = nativeAssistPointerVar0;
return retVal;
}

/// <summary>
/// p5, p6 and p7 seems to be about the same as p4, p5 and p6 for GET_CLOSEST_VEHICLE_NODE. p6 and/or p7 has something to do with finding a node on the same path/road and same direction(at least for this native, something to do with the heading maybe). Edit this when you find out more.<br /><br />nodeType: 0 = main roads, 1 = any dry path, 3 = water<br />p6 is always 3.0<br />p7 is always 0<br /><br />gtaforums.com/topic/843561-pathfind-node-types<br /><br />Example of usage, moving vehicle to closest path/road:<br />Vector3 coords = ENTITY::GET_ENTITY_COORDS(playerVeh, true);<br />Vector3 closestVehicleNodeCoords; <br />float roadHeading; <br />PATHFIND::GET_CLOSEST_VEHICLE_NODE_WITH_HEADING(coords.x, coords.y, coords.z, &amp;closestVehicleNodeCoords, &amp;roadHeading, 1, 3, 0); <br />ENTITY::SET_ENTITY_HEADING(playerVeh, roadHeading);<br />ENTITY::SET_ENTITY_COORDS(playerVeh, closestVehicleNodeCoords.x, closestVehicleNodeCoords.y, closestVehicleNodeCoords.z, 1, 0, 0, 1);<br />VEHICLE::SET_VEHICLE_ON_GROUND_PROPERLY(playerVeh);<br /><br />------------------------------------------------------------------<br />C# Example (ins1de) : https://pastebin.com/fxtMWAHD
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xFF071FB798B803B0<br />
/// </para>
/// </remarks>
public static bool GetClosestVehicleNodeWithHeading(float x, float y, float z, ref Vector3 outPosition, ref float outHeading, int nodeType, float p6, float p7){
var nativeAssistPointerVar0 = outPosition;
var nativeAssistPointerVar1 = outHeading;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0xFF071FB798B803B0uL, x, y, z, &nativeAssistPointerVar0, &nativeAssistPointerVar1, nodeType, p6, p7);
}
outPosition = nativeAssistPointerVar0;
outHeading = nativeAssistPointerVar1;
return retVal;
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xE50E52416CCF948B<br />
/// </para>
/// </remarks>
public static bool GetNthClosestVehicleNode(float x, float y, float z, int nthClosest, ref Vector3 outPosition, int nodeFlags, float unknown1, float unknown2){
var nativeAssistPointerVar0 = outPosition;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0xE50E52416CCF948BuL, x, y, z, nthClosest, &nativeAssistPointerVar0, nodeFlags, unknown1, unknown2);
}
outPosition = nativeAssistPointerVar0;
return retVal;
}

/// <summary>
/// Returns the id.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x22D7275A79FE8215<br />
/// </para>
/// </remarks>
public static int GetNthClosestVehicleNodeId(float x, float y, float z, int nth, int nodeFlags, float p5, float p6){
return Function.Call<int>((Hash)0x22D7275A79FE8215uL, x, y, z, nth, nodeFlags, p5, p6);
}

/// <summary>
/// Get the nth closest vehicle node and its heading.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x80CA6A8B6C094CC4<br />
/// </para>
/// </remarks>
public static bool GetNthClosestVehicleNodeWithHeading(float x, float y, float z, int nthClosest, ref Vector3 outPosition, ref float outHeading, ref int outNumLanes, int nodeFlags, float unknown3, float unknown4){
var nativeAssistPointerVar0 = outPosition;
var nativeAssistPointerVar1 = outHeading;
var nativeAssistPointerVar2 = outNumLanes;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0x80CA6A8B6C094CC4uL, x, y, z, nthClosest, &nativeAssistPointerVar0, &nativeAssistPointerVar1, &nativeAssistPointerVar2, nodeFlags, unknown3, unknown4);
}
outPosition = nativeAssistPointerVar0;
outHeading = nativeAssistPointerVar1;
outNumLanes = nativeAssistPointerVar2;
return retVal;
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x6448050E9C2A7207<br />
/// </para>
/// </remarks>
public static int GetNthClosestVehicleNodeIdWithHeading(float x, float y, float z, int nthClosest, ref Vector3 outPosition, ref float outHeading, int nodeFlags, float p7, float p8){
var nativeAssistPointerVar0 = outPosition;
var nativeAssistPointerVar1 = outHeading;
int retVal;
unsafe {
retVal = Function.Call<int>((Hash)0x6448050E9C2A7207uL, x, y, z, nthClosest, &nativeAssistPointerVar0, &nativeAssistPointerVar1, nodeFlags, p7, p8);
}
outPosition = nativeAssistPointerVar0;
outHeading = nativeAssistPointerVar1;
return retVal;
}

/// <summary>
/// See gtaforums.com/topic/843561-pathfind-node-types for node type info. 0 = paved road only, 1 = any road, 3 = water<br /><br />p10 always equals 3.0<br />p11 always equals 0
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x45905BE8654AE067<br />
/// </para>
/// </remarks>
public static bool GetNthClosestVehicleNodeFavourDirection(float x, float y, float z, float desiredX, float desiredY, float desiredZ, int nthClosest, ref Vector3 outPosition, ref float outHeading, int nodeFlags, float p10, float p11){
var nativeAssistPointerVar0 = outPosition;
var nativeAssistPointerVar1 = outHeading;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0x45905BE8654AE067uL, x, y, z, desiredX, desiredY, desiredZ, nthClosest, &nativeAssistPointerVar0, &nativeAssistPointerVar1, nodeFlags, p10, p11);
}
outPosition = nativeAssistPointerVar0;
outHeading = nativeAssistPointerVar1;
return retVal;
}

/// <summary>
/// Gets the density and flags of the closest node to the specified position.<br />Density is a value between 0 and 15, indicating how busy the road is.<br />Flags is a bit field.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x0568566ACBB5DEDC<br />
/// </para>
/// </remarks>
public static bool GetVehicleNodeProperties(float x, float y, float z, ref int density, ref int flags){
var nativeAssistPointerVar0 = density;
var nativeAssistPointerVar1 = flags;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0x0568566ACBB5DEDCuL, x, y, z, &nativeAssistPointerVar0, &nativeAssistPointerVar1);
}
density = nativeAssistPointerVar0;
flags = nativeAssistPointerVar1;
return retVal;
}

/// <summary>
/// Returns true if the id is non zero.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x1EAF30FCFBF5AF74<br />
/// </para>
/// </remarks>
public static bool IsVehicleNodeIdValid(int vehicleNodeId){
return Function.Call<bool>((Hash)0x1EAF30FCFBF5AF74uL, vehicleNodeId);
}

/// <summary>
/// Calling this with an invalid node id, will crash the game.<br />Note that IS_VEHICLE_NODE_ID_VALID simply checks if nodeId is not zero. It does not actually ensure that the id is valid.<br />Eg. IS_VEHICLE_NODE_ID_VALID(1) will return true, but will crash when calling GET_VEHICLE_NODE_POSITION().
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x703123E5E7D429C2<br />
/// </para>
/// </remarks>
public static void GetVehicleNodePosition(int nodeId, ref Vector3 outPosition){
var nativeAssistPointerVar0 = outPosition;
unsafe {
Function.Call((Hash)0x703123E5E7D429C2uL, nodeId, &nativeAssistPointerVar0);
}
outPosition = nativeAssistPointerVar0;
}

/// <summary>
/// Returns false for nodes that aren&apos;t used for GPS routes.<br />Example:<br />Nodes in Fort Zancudo and LSIA are false
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xA2AE5C478B96E3B6<br />
/// </para>
/// </remarks>
public static bool GetVehicleNodeIsGpsAllowed(int nodeID){
return Function.Call<bool>((Hash)0xA2AE5C478B96E3B6uL, nodeID);
}

/// <summary>
/// Returns true when the node is Offroad. Alleys, some dirt roads, and carparks return true.<br />Normal roads where plenty of Peds spawn will return false
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x4F5070AA58F69279<br />
/// </para>
/// </remarks>
public static bool GetVehicleNodeIsSwitchedOff(int nodeID){
return Function.Call<bool>((Hash)0x4F5070AA58F69279uL, nodeID);
}

/// <summary>
/// p1 seems to be always 1.0f in the scripts
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x132F52BBA570FE92<br />
/// </para>
/// </remarks>
public static bool GetClosestRoad(float x, float y, float z, float p3, int p4, ref Vector3 p5, ref Vector3 p6, int /* bug: structure */ p7, int /* bug: structure */ p8, ref float p9, bool p10){
var nativeAssistPointerVar0 = p5;
var nativeAssistPointerVar1 = p6;
var nativeAssistPointerVar2 = p9;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0x132F52BBA570FE92uL, x, y, z, p3, p4, &nativeAssistPointerVar0, &nativeAssistPointerVar1, p7, p8, &nativeAssistPointerVar2, p10);
}
p5 = nativeAssistPointerVar0;
p6 = nativeAssistPointerVar1;
p9 = nativeAssistPointerVar2;
return retVal;
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 2802<br />
/// <b>Native ID:</b> 0xC2AB6BFE34E92F8B<br />
/// </para>
/// </remarks>
public static bool LoadAllPathNodes(bool set){
return Function.Call<bool>((Hash)0xC2AB6BFE34E92F8BuL, set);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x228E5C6AD4D74BFD<br />
/// </para>
/// </remarks>
public static void SetAllowStreamPrologueNodes(bool toggle){
Function.Call((Hash)0x228E5C6AD4D74BFDuL, toggle);
}

/// <summary>
/// Activates Cayo Perico path nodes if passed `1`. GPS navigation will start working, maybe more stuff will change, not sure. It seems if you try to unload (pass `0`) when close to the island, your game might crash.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 2189<br />
/// <b>Native ID:</b> 0xF74B1FFA4A15FBEA<br />
/// </para>
/// </remarks>
public static void SetAllowStreamHeistIslandNodes(int type){
Function.Call((Hash)0xF74B1FFA4A15FBEAuL, type);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xF7B79A50B905A30D<br />
/// </para>
/// </remarks>
public static bool AreNodesLoadedForArea(float x1, float y1, float x2, float y2){
return Function.Call<bool>((Hash)0xF7B79A50B905A30DuL, x1, y1, x2, y2);
}

/// <summary>
/// Used internally for long range tasks
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x07FB139B592FA687<br />
/// </para>
/// </remarks>
public static bool RequestPathNodesInAreaThisFrame(float x1, float y1, float x2, float y2){
return Function.Call<bool>((Hash)0x07FB139B592FA687uL, x1, y1, x2, y2);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x1EE7063B80FFC77C<br />There were parameter(s) that was labeled as <b>Any</b>, and these had been written as <c>int</c> by generator.
/// </para>
/// </remarks>
public static void SetRoadsBackToOriginal(float p0, float p1, float p2, float p3, float p4, float p5, int /* bug: Any */ p6){
Function.Call((Hash)0x1EE7063B80FFC77CuL, p0, p1, p2, p3, p4, p5, p6);
}

/// <summary>
/// See IS_POINT_IN_ANGLED_AREA for the definition of an angled area.<br />bool p7 - always 1
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x0027501B9F3B407E<br />There were parameter(s) that was labeled as <b>Any</b>, and these had been written as <c>int</c> by generator.
/// </para>
/// </remarks>
public static void SetRoadsBackToOriginalInAngledArea(float x1, float y1, float z1, float x2, float y2, float z2, float width, int /* bug: Any */ p7){
Function.Call((Hash)0x0027501B9F3B407EuL, x1, y1, z1, x2, y2, z2, width, p7);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x0B919E1FB47CC4E0<br />
/// </para>
/// </remarks>
public static void SetAmbientPedRangeMultiplierThisFrame(float multiplier){
Function.Call((Hash)0x0B919E1FB47CC4E0uL, multiplier);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xAA76052DDA9BFC3E<br />There were parameter(s) that was labeled as <b>Any</b>, and these had been written as <c>int</c> by generator.
/// </para>
/// </remarks>
public static void AdjustAmbientPedSpawnDensitiesThisFrame(int /* bug: Any */ p0, int /* bug: Any */ p1, int /* bug: Any */ p2, int /* bug: Any */ p3, int /* bug: Any */ p4, int /* bug: Any */ p5, int /* bug: Any */ p6){
Function.Call((Hash)0xAA76052DDA9BFC3EuL, p0, p1, p2, p3, p4, p5, p6);
}

/// <summary>
/// p6 is always 0
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xE04B48F2CC926253<br />There were parameter(s) that was labeled as <b>Any</b>, and these had been written as <c>int</c> by generator.
/// </para>
/// </remarks>
public static void SetPedPathsBackToOriginal(float x1, float y1, float z1, float x2, float y2, float z2, int /* bug: Any */ p6){
Function.Call((Hash)0xE04B48F2CC926253uL, x1, y1, z1, x2, y2, z2, p6);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x93E0DB8440B73A7D<br />
/// </para>
/// </remarks>
public static bool GetRandomVehicleNode(float x, float y, float z, float radius, bool p4, bool p5, bool p6, ref Vector3 outPosition, ref int nodeId){
var nativeAssistPointerVar0 = outPosition;
var nativeAssistPointerVar1 = nodeId;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0x93E0DB8440B73A7DuL, x, y, z, radius, p4, p5, p6, &nativeAssistPointerVar0, &nativeAssistPointerVar1);
}
outPosition = nativeAssistPointerVar0;
nodeId = nativeAssistPointerVar1;
return retVal;
}

/// <summary>
/// Determines the name of the street which is the closest to the given coordinates.<br /><br />x,y,z - the coordinates of the street<br />streetName - returns a hash to the name of the street the coords are on<br />crossingRoad - if the coordinates are on an intersection, a hash to the name of the crossing road<br /><br />Note: the names are returned as hashes, the strings can be returned using the function HUD::GET_STREET_NAME_FROM_HASH_KEY.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x2EB41072B4C1E4C0<br />
/// </para>
/// </remarks>
public static void GetStreetNameAtCoord(float x, float y, float z, ref uint streetName, ref uint crossingRoad){
var nativeAssistPointerVar0 = streetName;
var nativeAssistPointerVar1 = crossingRoad;
unsafe {
Function.Call((Hash)0x2EB41072B4C1E4C0uL, x, y, z, &nativeAssistPointerVar0, &nativeAssistPointerVar1);
}
streetName = nativeAssistPointerVar0;
crossingRoad = nativeAssistPointerVar1;
}

/// <summary>
/// p3 is 0 in the only game script occurrence (trevor3) but 1 doesn&apos;t seem to make a difference<br /><br />distToNxJunction seems to be the distance in metres * 10.0f<br /><br />direction:<br />0 = This happens randomly during the drive for seemingly no reason but if you consider that this native is only used in trevor3, it seems to mean &quot;Next frame, stop whatever&apos;s being said and tell the player the direction.&quot;<br />1 = Route is being calculated or the player is going in the wrong direction<br />2 = Please Proceed the Highlighted Route<br />3 = In (distToNxJunction) Turn Left<br />4 = In (distToNxJunction) Turn Right<br />5 = In (distToNxJunction) Keep Straight<br />6 = In (distToNxJunction) Turn Sharply To The Left<br />7 = In (distToNxJunction) Turn Sharply To The Right<br />8 = Route is being recalculated or the navmesh is confusing. This happens randomly during the drive but consistently at {2044.0358, 2996.6116, 44.9717} if you face towards the bar and the route needs you to turn right. In that particular case, it could be a bug with how the turn appears to be 270 deg. CCW instead of &quot;right.&quot; Either way, this seems to be the engine saying &quot;I don&apos;t know the route right now.&quot;<br /><br />return value set to 0 always
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xF90125F1F79ECDF8<br />
/// </para>
/// </remarks>
public static int GenerateDirectionsToCoord(float x, float y, float z, bool p3, ref int direction, ref float p5, ref float distToNxJunction){
var nativeAssistPointerVar0 = direction;
var nativeAssistPointerVar1 = p5;
var nativeAssistPointerVar2 = distToNxJunction;
int retVal;
unsafe {
retVal = Function.Call<int>((Hash)0xF90125F1F79ECDF8uL, x, y, z, p3, &nativeAssistPointerVar0, &nativeAssistPointerVar1, &nativeAssistPointerVar2);
}
direction = nativeAssistPointerVar0;
p5 = nativeAssistPointerVar1;
distToNxJunction = nativeAssistPointerVar2;
return retVal;
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x72751156E7678833<br />
/// </para>
/// </remarks>
public static void SetIgnoreNoGpsFlag(bool toggle){
Function.Call((Hash)0x72751156E7678833uL, toggle);
}

/// <summary>
/// See: SET_BLIP_ROUTE
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x1FC289A0C3FF470F<br />
/// </para>
/// </remarks>
public static void SetIgnoreNoGpsFlagUntilFirstNormalNode(bool toggle){
Function.Call((Hash)0x1FC289A0C3FF470FuL, toggle);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xDC20483CD3DD5201<br />
/// </para>
/// </remarks>
public static void SetGpsDisabledZone(float x1, float y1, float z1, float x2, float y2, float z3){
Function.Call((Hash)0xDC20483CD3DD5201uL, x1, y1, z1, x2, y2, z3);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xBBB45C3CF5C8AA85<br />
/// </para>
/// </remarks>
public static int GetGpsBlipRouteLength(){
return Function.Call<int>((Hash)0xBBB45C3CF5C8AA85uL);
}

/// <summary>
/// p3 can be 0, 1 or 2.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 505<br />
/// <b>Native ID:</b> 0xF3162836C28F9DA5<br />
/// </para>
/// </remarks>
public static bool GetPosAlongGpsTypeRoute(ref Vector3 result, bool p1, float p2, int p3){
var nativeAssistPointerVar0 = result;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0xF3162836C28F9DA5uL, &nativeAssistPointerVar0, p1, p2, p3);
}
result = nativeAssistPointerVar0;
return retVal;
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x869DAACBBE9FA006<br />
/// </para>
/// </remarks>
public static bool GetGpsBlipRouteFound(){
return Function.Call<bool>((Hash)0x869DAACBBE9FA006uL);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 463<br />
/// <b>Native ID:</b> 0xA0F8A7517A273C05<br />
/// </para>
/// </remarks>
public static bool GetRoadBoundaryUsingHeading(float x, float y, float z, float heading, ref Vector3 outPosition){
var nativeAssistPointerVar0 = outPosition;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0xA0F8A7517A273C05uL, x, y, z, heading, &nativeAssistPointerVar0);
}
outPosition = nativeAssistPointerVar0;
return retVal;
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x16F46FB18C8009E4<br />
/// </para>
/// </remarks>
public static bool GetPositionBySideOfRoad(float x, float y, float z, int p3, ref Vector3 outPosition){
var nativeAssistPointerVar0 = outPosition;
bool retVal;
unsafe {
retVal = Function.Call<bool>((Hash)0x16F46FB18C8009E4uL, x, y, z, p3, &nativeAssistPointerVar0);
}
outPosition = nativeAssistPointerVar0;
return retVal;
}

/// <summary>
/// Gets a value indicating whether the specified position is on a road.<br />The vehicle parameter is not implemented (ignored).
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x125BF4ABFC536B09<br />
/// </para>
/// </remarks>
public static bool IsPointOnRoad(float x, float y, float z, int /* Vehicle */ vehicle){
return Function.Call<bool>((Hash)0x125BF4ABFC536B09uL, x, y, z, vehicle);
}

/// <summary>
/// Gets the next zone that has been disabled using SET_GPS_DISABLED_ZONE_AT_INDEX.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xD3A6A0EF48823A8C<br />
/// </para>
/// </remarks>
public static int GetNextGpsDisabledZoneIndex(){
return Function.Call<int>((Hash)0xD3A6A0EF48823A8CuL);
}

/// <summary>
/// Disables the GPS route displayed on the minimap while within a certain zone (area). When in a disabled zone and creating a waypoint, the GPS route is not shown on the minimap until you are outside of the zone. When disabled, the direct distance is shown on minimap opposed to distance to travel. Seems to only work before setting a waypoint.<br />You can clear the disabled zone with CLEAR_GPS_DISABLED_ZONE_AT_INDEX.<br /><br />**Setting a waypoint at the same coordinate:**<br />Disabled Zone: https://i.imgur.com/P9VUuxM.png<br />Enabled Zone (normal): https://i.imgur.com/BPi24aw.png
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xD0BC1C6FB18EE154<br />
/// </para>
/// </remarks>
public static void SetGpsDisabledZoneAtIndex(float x1, float y1, float z1, float x2, float y2, float z2, int index){
Function.Call((Hash)0xD0BC1C6FB18EE154uL, x1, y1, z1, x2, y2, z2, index);
}

/// <summary>
/// Clears a disabled GPS route area from a certain index previously set using `SET_GPS_DISABLED_ZONE_AT_INDEX`.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x2801D0012266DF07<br />
/// </para>
/// </remarks>
public static void ClearGpsDisabledZoneAtIndex(int index){
Function.Call((Hash)0x2801D0012266DF07uL, index);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x387EAD7EE42F6685<br />
/// </para>
/// </remarks>
public static void AddNavmeshRequiredRegion(float x, float y, float radius){
Function.Call((Hash)0x387EAD7EE42F6685uL, x, y, radius);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x916F0A3CDEC3445E<br />
/// </para>
/// </remarks>
public static void RemoveNavmeshRequiredRegions(){
Function.Call((Hash)0x916F0A3CDEC3445EuL);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 944<br />
/// <b>Native ID:</b> 0x705A844002B39DC0<br />
/// </para>
/// </remarks>
public static bool IsNavmeshRequiredRegionInUse(){
return Function.Call<bool>((Hash)0x705A844002B39DC0uL);
}

/// <summary>
/// Set toggle true to disable navmesh.<br />Set toggle false to enable navmesh.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x4C8872D8CDBE1B8B<br />
/// </para>
/// </remarks>
public static void DisableNavmeshInArea(float x1, float y1, float z1, float x2, float y2, float z2, bool toggle){
Function.Call((Hash)0x4C8872D8CDBE1B8BuL, x1, y1, z1, x2, y2, z2, toggle);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x8415D95B194A3AEA<br />
/// </para>
/// </remarks>
public static bool AreAllNavmeshRegionsLoaded(){
return Function.Call<bool>((Hash)0x8415D95B194A3AEAuL);
}

/// <summary>
/// Returns whether navmesh for the region is loaded. The region is a rectangular prism defined by it&apos;s top left deepest corner to it&apos;s bottom right shallowest corner.<br /><br />If you can re-word this so it makes more sense, please do. I&apos;m horrible with words sometimes...
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xF813C7E63F9062A5<br />
/// </para>
/// </remarks>
public static bool IsNavmeshLoadedInArea(float x1, float y1, float z1, float x2, float y2, float z2){
return Function.Call<bool>((Hash)0xF813C7E63F9062A5uL, x1, y1, z1, x2, y2, z2);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x01708E8DD3FF8C65<br />
/// </para>
/// </remarks>
public static int GetNumNavmeshesExistingInArea(float x1, float y1, float z1, float x2, float y2, float z2){
return Function.Call<int>((Hash)0x01708E8DD3FF8C65uL, x1, y1, z1, x2, y2, z2);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xFCD5C8E06E502F5A<br />There were parameter(s) that was labeled as <b>Any</b>, and these had been written as <c>int</c> by generator.
/// </para>
/// </remarks>
public static int AddNavmeshBlockingObject(float p0, float p1, float p2, float p3, float p4, float p5, float p6, bool p7, int /* bug: Any */ p8){
return Function.Call<int>((Hash)0xFCD5C8E06E502F5AuL, p0, p1, p2, p3, p4, p5, p6, p7, p8);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x109E99373F290687<br />There were parameter(s) that was labeled as <b>Any</b>, and these had been written as <c>int</c> by generator.
/// </para>
/// </remarks>
public static void UpdateNavmeshBlockingObject(int /* bug: Any */ p0, float p1, float p2, float p3, float p4, float p5, float p6, float p7, int /* bug: Any */ p8){
Function.Call((Hash)0x109E99373F290687uL, p0, p1, p2, p3, p4, p5, p6, p7, p8);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x46399A7895957C0E<br />There were parameter(s) that was labeled as <b>Any</b>, and these had been written as <c>int</c> by generator.
/// </para>
/// </remarks>
public static void RemoveNavmeshBlockingObject(int /* bug: Any */ p0){
Function.Call((Hash)0x46399A7895957C0EuL, p0);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x0EAEB0DB4B132399<br />There were parameter(s) that was labeled as <b>Any</b>, and these had been written as <c>int</c> by generator.
/// </para>
/// </remarks>
public static bool DoesNavmeshBlockingObjectExist(int /* bug: Any */ p0){
return Function.Call<bool>((Hash)0x0EAEB0DB4B132399uL, p0);
}

/// <summary>
/// Returns CGameWorldHeightMap&apos;s maximum Z value at specified point (grid node).
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x29C24BFBED8AB8FB<br />
/// </para>
/// </remarks>
public static float GetApproxHeightForPoint(float x, float y){
return Function.Call<float>((Hash)0x29C24BFBED8AB8FBuL, x, y);
}

/// <summary>
/// Returns CGameWorldHeightMap&apos;s maximum Z among all grid nodes that intersect with the specified rectangle.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x8ABE8608576D9CE3<br />
/// </para>
/// </remarks>
public static float GetApproxHeightForArea(float x1, float y1, float x2, float y2){
return Function.Call<float>((Hash)0x8ABE8608576D9CE3uL, x1, y1, x2, y2);
}

/// <summary>
/// Returns CGameWorldHeightMap&apos;s minimum Z value at specified point (grid node).
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x336511A34F2E5185<br />
/// </para>
/// </remarks>
public static float GetApproxFloorForPoint(float x, float y){
return Function.Call<float>((Hash)0x336511A34F2E5185uL, x, y);
}

/// <summary>
/// Returns CGameWorldHeightMap&apos;s minimum Z among all grid nodes that intersect with the specified rectangle.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x3599D741C9AC6310<br />
/// </para>
/// </remarks>
public static float GetApproxFloorForArea(float x1, float y1, float x2, float y2){
return Function.Call<float>((Hash)0x3599D741C9AC6310uL, x1, y1, x2, y2);
}

/// <summary>
/// Calculates the travel distance between a set of points.<br /><br />Doesn&apos;t seem to correlate with distance on gps sometimes.<br />This function returns the value 100000.0 over long distances, seems to be a failure mode result, potentially occurring when not all path nodes are loaded into pathfind.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> Pathfind<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xADD95C7005C4A197<br />
/// </para>
/// </remarks>
public static float CalculateTravelDistanceBetweenPoints(float x1, float y1, float z1, float x2, float y2, float z2){
return Function.Call<float>((Hash)0xADD95C7005C4A197uL, x1, y1, z1, x2, y2, z2);
}

}}
